pcl::PassThrough< PointT > Class Template Reference
Module filters

PassThrough passes points in a cloud based on constraints for one particular field of the point type. More...

`#include <pcl/filters/passthrough.h>`

Inheritance diagram for pcl::PassThrough< PointT >:

## Public Types

using | Ptr = shared_ptr< PassThrough< PointT > >
using | ConstPtr = shared_ptr< const PassThrough< PointT > >
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | Ptr = shared_ptr< FilterIndices< PointT > >
using | ConstPtr = shared_ptr< const FilterIndices< PointT > >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr< Filter< PointT > >
using | ConstPtr = shared_ptr< const Filter< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| PassThrough (bool extract_removed_indices=false)
| Constructor. More...
void | setFilterFieldName (const std::string &field_name)
| Provide the name of the field to be used for filtering data. More...
std::string const | getFilterFieldName () const
| Retrieve the name of the field to be used for filtering data. More...
void | setFilterLimits (const float &limit_min, const float &limit_max)
| Set the numerical limits for the field for filtering data. More...
void | getFilterLimits (float &limit_min, float &limit_max) const
| Get the numerical limits for the field for filtering data. More...
void | setFilterLimitsNegative (const bool limit_negative)
| Set to true if we want to return the data outside the interval specified by setFilterLimits (min, max) Default: false. More...
void | getFilterLimitsNegative (bool &limit_negative) const
| Get whether the data outside the interval (min/max) is to be returned (true) or inside (false). More...
bool | getFilterLimitsNegative () const
| Get whether the data outside the interval (min/max) is to be returned (true) or inside (false). More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

using | PointCloud = typename FilterIndices< PointT >::PointCloud
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | FieldList = typename pcl::traits::fieldList< PointT >::type

## Protected Member Functions

void | applyFilter (Indices &indices) override
| Filtered results are indexed by an indices array. More...
void | applyFilterIndices (Indices &indices)
| Filtered results are indexed by an indices array. More...
Protected Member Functions inherited from pcl::FilterIndices< PointT >
void | applyFilter (PointCloud &output) override
| Abstract filter method for point cloud. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::PassThrough< PointT >

PassThrough passes points in a cloud based on constraints for one particular field of the point type.

Iterates through the entire input once, automatically filtering non-finite points and the points outside the interval specified by setFilterLimits(), which applies only to the field specified by setFilterFieldName().
Usage example:

pcl::PassThrough<PointType> ptfilter (true); // Initializing with true will allow us to extract the removed indices
ptfilter.setInputCloud (cloud_in);
ptfilter.setFilterFieldName ("x");
ptfilter.setFilterLimits (0.0, 1000.0);
ptfilter.filter (*indices_x);
// The indices_x array indexes all points of cloud_in that have x between 0.0 and 1000.0
indices_rem = ptfilter.getRemovedIndices ();
// The indices_rem array indexes all points of cloud_in that have x smaller than 0.0 or larger than 1000.0
// and also indexes all non-finite points of cloud_in
ptfilter.setIndices (indices_x);
ptfilter.setFilterFieldName ("z");
ptfilter.setFilterLimits (-10.0, 10.0);
ptfilter.setNegative (true);
ptfilter.filter (*indices_xz);
// The indices_xz array indexes all points of cloud_in that have x between 0.0 and 1000.0 and z larger than 10.0 or smaller than -10.0
ptfilter.setIndices (indices_xz);
ptfilter.setFilterFieldName ("intensity");
ptfilter.setFilterLimits (FLT_MIN, 0.5);
ptfilter.setNegative (false);
ptfilter.filter (*cloud_out);
// The resulting cloud_out contains all points of cloud_in that are finite and have:
// x between 0.0 and 1000.0, z larger than 10.0 or smaller than -10.0 and intensity smaller than 0.5.
pcl::PassThrough
PassThrough passes points in a cloud based on constraints for one particular field of the point type.
Definition: passthrough.h:82

Author
  Radu Bogdan Rusu

Definition at line 81 of file passthrough.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT >

using pcl::PassThrough< PointT >::ConstPtr = shared_ptr<const PassThrough<PointT> >

Definition at line 92 of file passthrough.h.

## FieldList

template<typename PointT >

using pcl::PassThrough< PointT >::FieldList = typename pcl::traits::fieldList<PointT>::type

protected

Definition at line 87 of file passthrough.h.

## PointCloud

template<typename PointT >

using pcl::PassThrough< PointT >::PointCloud = typename FilterIndices<PointT>::PointCloud

protected

Definition at line 84 of file passthrough.h.

## PointCloudConstPtr

template<typename PointT >

using pcl::PassThrough< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

protected

Definition at line 86 of file passthrough.h.

## PointCloudPtr

template<typename PointT >

using pcl::PassThrough< PointT >::PointCloudPtr = typename PointCloud::Ptr

protected

Definition at line 85 of file passthrough.h.

## Ptr

template<typename PointT >

using pcl::PassThrough< PointT >::Ptr = shared_ptr<PassThrough<PointT> >

Definition at line 91 of file passthrough.h.

## Constructor & Destructor Documentation

## PassThrough()

template<typename PointT >

pcl::PassThrough< PointT >::PassThrough | ( | bool | extract_removed_indices = `false` | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 98 of file passthrough.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter()

template<typename PointT >

void pcl::PassThrough< PointT >::applyFilter | ( | Indices & | indices | ) |

inline override protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 197 of file passthrough.h.

References pcl::PassThrough< PointT >::applyFilterIndices().

## applyFilterIndices()

template<typename PointT >

void pcl::PassThrough< PointT >::applyFilterIndices | ( | Indices & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 47 of file passthrough.hpp.

Referenced by pcl::PassThrough< PointT >::applyFilter().

## getFilterFieldName()

template<typename PointT >

std::string const pcl::PassThrough< PointT >::getFilterFieldName | ( |  | ) | const

inline

Retrieve the name of the field to be used for filtering data.

Returns
  The name of the field that will be used for filtering.

Definition at line 121 of file passthrough.h.

## getFilterLimits()

template<typename PointT >

void pcl::PassThrough< PointT >::getFilterLimits | ( | float & | limit_min,
|  | float & | limit_max
| ) |  | const

inline

Get the numerical limits for the field for filtering data.

Parameters

  [out] | limit_min | The minimum allowed field value (default = FLT_MIN).
  [out] | limit_max | The maximum allowed field value (default = FLT_MAX).

Definition at line 143 of file passthrough.h.

## getFilterLimitsNegative() [1/2]

template<typename PointT >

bool pcl::PassThrough< PointT >::getFilterLimitsNegative | ( |  | ) | const

inline

Get whether the data outside the interval (min/max) is to be returned (true) or inside (false).

Warning
  This method will be removed in the future. Use getNegative() instead.

Returns
  true if data outside the interval [min; max] is to be returned, false otherwise

Definition at line 177 of file passthrough.h.

References pcl::FilterIndices< PointT >::negative_.

## getFilterLimitsNegative() [2/2]

template<typename PointT >

void pcl::PassThrough< PointT >::getFilterLimitsNegative | ( | bool & | limit_negative | ) | const

inline

Get whether the data outside the interval (min/max) is to be returned (true) or inside (false).

Warning
  This method will be removed in the future. Use getNegative() instead.

Parameters

  [out] | limit_negative | true if data outside the interval [min; max] is to be returned, false otherwise

Deprecated:
  Scheduled for removal in version 1 . 13 : "use inherited FilterIndices::getNegative() instead"

Definition at line 167 of file passthrough.h.

References pcl::FilterIndices< PointT >::negative_.

## setFilterFieldName()

template<typename PointT >

void pcl::PassThrough< PointT >::setFilterFieldName | ( | const std::string & | field_name | ) |

inline

Provide the name of the field to be used for filtering data.

In conjunction with setFilterLimits(), points having values outside this interval for this field will be discarded.

Parameters

  [in] | field_name | The name of the field that will be used for filtering.

Definition at line 112 of file passthrough.h.

Referenced by pcl::tracking::ParticleFilterTracker< PointInT, StateT >::ParticleFilterTracker().

## setFilterLimits()

template<typename PointT >

void pcl::PassThrough< PointT >::setFilterLimits | ( | const float & | limit_min,
|  | const float & | limit_max
| ) |  |

inline

Set the numerical limits for the field for filtering data.

In conjunction with setFilterFieldName(), points having values outside this interval for this field will be discarded.

Parameters

  [in] | limit_min | The minimum allowed field value (default = FLT_MIN).
  [in] | limit_max | The maximum allowed field value (default = FLT_MAX).

Definition at line 132 of file passthrough.h.

## setFilterLimitsNegative()

template<typename PointT >

void pcl::PassThrough< PointT >::setFilterLimitsNegative | ( | const bool | limit_negative | ) |

inline

Set to true if we want to return the data outside the interval specified by setFilterLimits (min, max) Default: false.

Warning
  This method will be removed in the future. Use setNegative() instead.

Parameters

  [in] | limit_negative | return data inside the interval (false) or outside (true)

Deprecated:
  Scheduled for removal in version 1 . 13 : "use inherited FilterIndices::setNegative() instead"

Definition at line 156 of file passthrough.h.

References pcl::FilterIndices< PointT >::negative_.

The documentation for this class was generated from the following files:

- pcl/filters/passthrough.h
- pcl/filters/impl/passthrough.hpp